<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { isPlayerActive, anyLegalPlacement } from "../utils";
  import Card from "./Card.svelte";
  import Flag from "./Flag.svelte";

  const dispatch = createEventDispatcher();

  export let player: PlayerState;
  export let state: GameState;
  export let isUser: boolean = false;
  export let mode: Mode | null;

  $: isActive = isPlayerActive(state.phase, player.id);

  $: handIsSelectable =
    isActive &&
    isUser &&
    state.phase[0] === "placing" &&
    (mode === null || mode.name === "placing-card");

  let cards: CardId[];
  $: {
    cards = [...player.hand];
    if (isUser) {
      cards.sort((a, b) => a - b);
    }
  }

  function getHandCardStyle(idx: number, size: number): string {
    const step = 2;
    const start = ((1 - size) * step) / 2;
    const offset = start + step * idx;
    return `
      --hand-card-degs: ${offset}deg;
      --hand-card-offset-x: ${offset}em;
      `;
  }

  let failedClaim: FailedClaim | null;
  $: failedClaim = state.phase[0] !== "ended" ? state.phase[2] : null;
</script>

<div class="player relative" class:user={isUser}>
  <div class="hand">
    {#each cards as card, cardIdx (card)}
      <button
        class="hand-card invisibutton"
        class:selected={mode?.name === "placing-card" &&
          mode.selectedCard === card}
        style={getHandCardStyle(cardIdx, cards.length)}
        disabled={!handIsSelectable}
        on:click={() => dispatch("select_card", card)}
      >
        <Card {card} facedown={!isUser} />
      </button>
    {/each}
  </div>

  <gs6-player-box playerid={player.id} thinking={isActive}>
    <span slot="after-name">
      <Flag players={state.players} playerId={player.id} />
    </span>
  </gs6-player-box>

  {#if isUser && isPlayerActive(state.phase, player.id)}
    <div class="right-button">
      {#if mode?.name === "claiming-battle"}
        <button class="secondary" on:click={() => dispatch("cancel_click")}>
          Cancel
        </button>
      {:else}
        <div class="relative">
          <button
            class="claim primary"
            on:click={() => dispatch("claim_click")}
            disabled={!!failedClaim}
          >
            Plant flag
          </button>
          {#if failedClaim}
            <div class="absolute opacity-75 text-sm mt-1 w-[125%]">
              You have already failed an attempt this turn.
            </div>
          {/if}
        </div>
      {/if}
    </div>

    {#if state.phase[0] === "placing" && !anyLegalPlacement(player, state.claims)}
      <div class="left-button">
        <button class="secondary" on:click={() => dispatch("skip_click")}>
          Skip!
        </button>
      </div>
    {/if}
  {/if}
</div>

<style>
  .player {
    margin-top: 5em;
  }
  .player.user {
    margin-top: 7.5em;
  }

  .user .hand {
    font-size: 133%;
  }

  .hand-card {
    --hand-card-offset-y: 0;
    --hand-card-offset-origin: 50em;

    text-align: inherit;
    position: absolute;
    top: 2.5rem;
    left: 50%;
    transform: translate(-50%, -100%) translateY(var(--hand-card-offset-origin))
      rotate(var(--hand-card-degs))
      translateY(calc(-1 * var(--hand-card-offset-origin)))
      translateY(var(--hand-card-offset-y));

    transition: transform 0.2s;
  }

  .hand-card:not(:disabled) {
    cursor: pointer;
  }

  .hand-card:not(:disabled):not(.selected):hover,
  .hand-card:not(:disabled):not(.selected):focus {
    --hand-card-offset-y: -1rem;
  }
  .hand-card.selected {
    --hand-card-offset-y: -1.33rem;
    border-radius: 3px;
    outline: 0.33rem solid;
    outline-offset: 0.125rem;
    outline-color: var(--gs6-accent-color);
  }

  .right-button {
    position: absolute;
    right: -0.5rem;
    bottom: 0.5rem;
    transform: translateX(100%);
  }

  .left-button {
    position: absolute;
    left: -0.5rem;
    bottom: 0.5rem;
    transform: translateX(-100%);
  }
</style>
